/*
 * © 2021, 2022 David Vines
 *
 * sumoOyakata is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * any later version.
 *
 * sumoOyakata is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with sumoOyakata. If not, see https://www.gnu.org/licenses/gpl-2.0.html.
 */
/* globals ROT */
/* exported Names */
var Names = {
	generator: new ROT.StringGenerator({prior:0, order:3}),
	init: function() {
		let g = this.generator;
		let names = [
		"Abi",
		"Akebono",
		"Akinoshima",
		"Akinoshu",
		"Akinoyama",
		"Akiseyama",
		"Akiyoshi",
		"Akua",
		"Amakaze",
		"Amane",
		"Amanoyama",
		"Amatsukaze",
		"Aminishiki",
		"Amuru",
		"Annenyama",
		"Aobajo",
		"Aobayama",
		"Aogiyama",
		"Aoiyama",
		"Aonosato",
		"Aotsurugi",
		"Araiwa",
		"Arauma",
		"Arakiyama",
		"Aran",
		"Arase",
		"Arashiyama",
		"Aratoshi",
		"Arawashi",
		"Asaarashi",
		"Asabenkei",
		"Asagyokusei",
		"Asahifuji",
		"Asahikuni",
		"Asahisato",
		"Asahisho",
		"Asahitaka",
		"Asahiyutaka",
		"Asakiryu",
		"Asanobori",
		"Asanosho",
		"Asanowaka",
		"Asanoyama",
		"Asasegawa",
		"Asasekiryu",
		"Asashoryu",
		"Asofuji",
		"Atamifuji",
		"Azumakase",
		"Azumanishiki",
		"Azumao",
		"Azumaryu",
		"Banryuyama",
		"Baruto",
		"Bishuyama",
		"Bushozan",
		"Bushuyama",
		"Buyuzan",
		"Chikubayama",
		"Chiyoarashi",
		"Chiyodaigo",
		"Chiyohakuho",
		"Chiyohakuryu",
		"Chiyomaru",
		"Chiyonofuji",
		"Chiyonokuni",
		"Chiyonoo",
		"Chiyonoo",
		"Chiyonoumi",
		"Chiyonoumi",
		"Chiyonoyama",
		"Chiyootori",
		"Chiyootori",
		"Chiyoshoma",
		"Chiyotaikai",
		"Chiyotairyu",
		"Chiyotenzan",
		"Chiyozakura",
		"Churanoumi",
		"Daiamami",
		"Daibanjaku",
		"Daido",
		"Daieisho",
		"Daigaku",
		"Daigo",
		"Daihi",
		"Daiju",
		"Daijuyama",
		"Daikirin",
		"Daikisho",
		"Daimanazuru",
		"Daimonji",
		"Dairaido",
		"Dairyu",
		"Dairyugawa",
		"Daiseido",
		"Daishi",
		"Daishochi",
		"Daishodai",
		"Daishoho",
		"Daishomaru",
		"Daishosei",
		"Daishoumi",
		"Daishoyama",
		"Daitenma",
		"Daitensho",
		"Daitenzan",
		"Daitetsu",
		"Daiyu",
		"Daiyubu",
		"Daizen",
		"Dejima",
		"Dewaarashi",
		"Dewaminato",
		"Dewanishiki",
		"Dewanohana",
		"Dewanojo",
		"Dewanoryu",
		"Dewanosato",
		"Dewaotori",
		"Dewataikai",
		"Edomura",
		"Eigayama",
		"Enazakura",
		"Endo",
		"Enho",
		"Fudoyama",
		"Fujiazuma",
		"Fujikawa",
		"Fujinishiki",
		"Fujinokawa",
		"Fujinoshin",
		"Fujiseiun",
		"Fujiyuho",
		"Fujizakura",
		"Fukai",
		"Fukamiyama",
		"Fukunohana",
		"Fukunoshima",
		"Furanshishu",
		"Furuichi",
		"Fusanishiki",
		"Futabayama",
		"Futagodake",
		"Futagoryu",
		"Futahaguro",
		"Futatsuryu",
		"Futeno",
		"Gagamaru",
		"Gaia",
		"Ganyu",
		"Gochozan",
		"Goeido",
		"Gojoro",
		"Gokushindo",
		"Goshimaru",
		"Hachiya",
		"Hagurohana",
		"Haguroiwa",
		"Haguroyama",
		"Hakuba",
		"Hakuho",
		"Hakurozan",
		"Hakuyozan",
		"Hamadayama",
		"Hamanishiki",
		"Hamanoshima",
		"Hanada",
		"Hanafusa",
		"Hanahikari",
		"Hanakaze",
		"Hananokuni",
		"Hananosato",
		"Hananoumi",
		"Harimayama",
		"Harumafuji",
		"Harunoyama",
		"Hasegawa",
		"Hatooka",
		"Hatsuyama",
		"Hattori",
		"Hayatefuji",
		"Hayateumi",
		"Hibikiryu",
		"Hidanohana",
		"Hidenohana",
		"Hidenokuni",
		"Hidenoumi",
		"Higonojo",
		"Higonoumi",
		"Hinataryu",
		"Hinodeshima",
		"Hiraga",
		"Hishofuji",
		"Hitachiyama",
		"Hitenryu",
		"Hochiyama",
		"Hochiyama",
		"Hokako",
		"Hokuseiho",
		"Hokutenkai",
		"Hokutenyu",
		"Hokutofuji",
		"Hokutoiwa",
		"Hokutokuni",
		"Hokutoriki",
		"Hokutoshu",
		"Hokutoumi",
		"Homarefuji",
		"Homarenishiki",
		"Homasho",
		"Hoo",
		"Hoshihkari",
		"Hoshiiwato",
		"Hoshikabuto",
		"Hoshikaze",
		"Hoshitango",
		"Hoshoryu",
		"Hoshuzan",
		"Hozan",
		"Ichinojo",
		"Ichinotani",
		"Ichinoya",
		"Ichiyamamoto",
		"Ikioi",
		"Imafuku",
		"Inazuma",
		"Inoue",
		"Irodori",
		"Ishinriki",
		"Ishiura",
		"Ishizaki",
		"Itai",
		"Iwakaze",
		"Iwakiyama",
		"Iwashita",
		"Jingaku",
		"Jinmaku",
		"Jokoryu",
		"Jumonji",
		"Juzan",
		"Kagamifuji",
		"Kagamio",
		"Kagamisato",
		"Kagayaki",
		"Kaido",
		"Kaihakuzan",
		"Kaiho",
		"Kaiketsu",
		"Kaiki",
		"Kainoshima",
		"Kainoyama",
		"Kaio",
		"Kairo",
		"Kairyuyama",
		"Kaisei",
		"Kaishin",
		"Kaisho",
		"Kakizoe",
		"Kakuryu",
		"Kamikiiwa",
		"Kamito",
		"Kanechika",
		"Kanenohana",
		"Kaneshiro",
		"Kanno",
		"Kanreki",
		"Kanzaki",
		"Kaonishiki",
		"Kashiwado",
		"Kasugafuji",
		"Kasuganishiki",
		"Kasugao",
		"Katayama",
		"Katsuhikari",
		"Kazafuzan",
		"Keitenkai",
		"Kengo",
		"Kimikaze",
		"Kiminishiki",
		"Kimurayama",
		"Kinbozan",
		"Kinkaiyama",
		"Kinoarashi",
		"Kinryuzan",
		"Kiribayama",
		"Kirimaru",
		"Kirinishiki",
		"Kirinji",
		"Kirinowaka",
		"Kirishima",
		"Kisenosato",
		"Kitaazuma",
		"Kitabayama",
		"Kitadaichi",
		"Kitaharima",
		"Kitakachidoki",
		"Kitakasuga",
		"Kitanofuji",
		"Kitanonada",
		"Kitanoumi",
		"Kitanowaka",
		"Kitaoji",
		"Kitaseumi",
		"Kitataiki",
		"Kitazakura",
		"Kiyokuni",
		"Kiyonomori",
		"Kiyonoumi",
		"Kiyoseumi",
		"Kizakiumi",
		"Kizenryu",
		"Kobo",
		"Koboyama",
		"Koki",
		"Kokkai",
		"Komafudo",
		"Komanokuni",
		"Kongo",
		"Konishiki",
		"Konuma",
		"Koryu",
		"Kosei",
		"Kotetsuyama",
		"Kotoanbai",
		"Kotobeppu",
		"Kotochitose",
		"Kotodairyu",
		"Kotoeko",
		"Kotofuji",
		"Kotogahama",
		"Kotogatake",
		"Kotogaume",
		"Kotoinazuma",
		"Kotokasuga",
		"Kotokaze",
		"Kotokuzan",
		"Kotokuzen",
		"Kotomisen",
		"Kotomitsuki",
		"Kotonishiki",
		"Kotonofuji",
		"Kotonomine",
		"Kotonomori",
		"Kotonowaka",
		"Kotoo",
		"Kotoosako",
		"Kotooshu",
		"Kotoryu",
		"Kotoshogiku",
		"Kotoshoho",
		"Kototebakari",
		"Kototenzan",
		"Kototsubaki",
		"Kotoyanagi",
		"Kotoyuki",
		"Kotoyusho",
		"Kotoyutaka",
		"Kotozakura",
		"Kuniazuma",
		"Kuninofuji",
		"Kurama",
		"Kurohimeyama",
		"Kurosegawa",
		"Kushimaumi",
		"Kyoda",
		"Kyokudozan",
		"Kyokugozan",
		"Kyokujishi",
		"Kyokunankai",
		"Kyokusetsuzan",
		"Kyokushuho",
		"Kyokushuzan",
		"Kyokutaisei",
		"Kyokutenho",
		"Kyokutenzan",
		"Maedagawa",
		"Maedaiko",
		"Maedayama",
		"Maenoshin",
		"Maenoyama",
		"Maenoyu",
		"Maikaze",
		"Maikera",
		"Mainoumi",
		"Manazuru",
		"Marusho",
		"Maruyama",
		"Masakaze",
		"Masatsukasa",
		"Masudayama",
		"Masunoyama",
		"Masurao",
		"Masuruami",
		"Matsunobori",
		"Matsuruyuyama",
		"Matutoo",
		"Meisei",
		"Midorifuji",
		"Mienoumi",
		"Minaminoshima",
		"Minatofuji",
		"Misugiiso",
		"Misugisato",
		"Mitakeumi",
		"Mitoizumi",
		"Mitoryu",
		"Mitsuneyama",
		"Miyabi",
		"Miyabiyama",
		"Miyagiyama",
		"Mokonami",
		"Mudoho",
		"Muryu",
		"Musashikuni",
		"Musashimaru",
		"Musoyama",
		"Mutsuarashi",
		"Myobudani",
		"Myogiryu",
		"Nagata",
		"Nakanokuni",
		"Naminohana",
		"Nanfu",
		"Nankairyu",
		"Nankaiyama",
		"Nanyozakura",
		"Nanzan",
		"Narutaki",
		"Naya",
		"Nayoroiwa",
		"Niigiyama",
		"Nionoumi",
		"Nishikifuji",
		"Nishikigi",
		"Obara",
		"Oga",
		"Oginishiki",
		"Oginohana",
		"Ohata",
		"Ohinode",
		"Oho",
		"Oikari",
		"Oikawa",
		"Oiteyama",
		"Oiwato",
		"Ojiyama",
		"Okanoyama",
		"Oki",
		"Okinoumi",
		"Oniarashi",
		"Onishiki",
		"Onohana",
		"Onojo",
		"Onokuni",
		"Onosho",
		"Onoumi",
		"Orora",
		"Oshio",
		"Oshoma",
		"Oshoryu",
		"Oshouma",
		"Oshoyama",
		"Osunaarashi",
		"Otsuji",
		"Ōtsuka",
		"Otsukasa",
		"Ouchiyama",
		"Oyutaka",
		"Ozura",
		"Ozutsu",
		"Raiden",
		"Raiko",
		"Rikidozan",
		"Rikio",
		"Rikishin",
		"Roga",
		"Roho",
		"Ryogoku",
		"Ryuden",
		"Ryuho",
		"Ryuki",
		"Ryuko",
		"Ryukozan",
		"Ryuo",
		"Ryuonami",
		"Ryutei",
		"Sachinoshima",
		"Sadanofuji",
		"Sadanohikari",
		"Sadanoumi",
		"Sadanoyama",
		"Saganohana",
		"Sagatsukasa",
		"Sakaekaze",
		"Sakahoko",
		"Sakai",
		"Sakaizawa",
		"Sakigake",
		"Sasshunada",
		"Satoyama",
		"Sawahikari",
		"Seiro",
		"Sensho",
		"Senshuyama",
		"Sentoryu",
		"Shiden",
		"Shikishima",
		"Shimanoumi",
		"shimazuumi",
		"Shimizugawa",
		"Shimotori",
		"Shimoyama",
		"Shinnishiki",
		"Shiratayama",
		"Shirononami",
		"Shironoryu",
		"Shishi",
		"Shishiho",
		"Shobushi",
		"Shodai",
		"Shohozan",
		"Shoketsu",
		"Shonannoumi",
		"Shotenro",
		"Shunketsu",
		"Sokokurai",
		"Soranoumi",
		"Sotairyu",
		"Sumanofuji",
		"Tagaryu",
		"Taiga",
		"Taiho",
		"Taikai",
		"Taiko",
		"Takaazuma",
		"Takagenji",
		"Takakeisho",
		"Takakento",
		"Takamifuji",
		"Takamio",
		"Takamisakari",
		"Takamishu",
		"Takamisugi",
		"Takamiyama",
		"Takanishiki",
		"Takanofuji",
		"Takanohana",
		"Takanoiwa",
		"Takanomine",
		"Takanonami",
		"Takanosato",
		"Takanosho",
		"Takanotsuru",
		"Takanoumi",
		"Takanowaka",
		"Takanoyama",
		"Takao",
		"Takarafuji",
		"Takarakuni",
		"Takaryu",
		"Takatoriki",
		"Takatsukasa",
		"Takayasu",
		"Takekaze",
		"Tamaarashi",
		"Tamaasuka",
		"Tamakairiki",
		"Tamakasuga",
		"Tamakirin",
		"Tamakiyama",
		"Tamanishiki",
		"Tamanofuji",
		"Tamanoshima",
		"Tamanoumi",
		"Tamarikido",
		"Tamaryu",
		"Tamashoho",
		"Tamawashi",
		"Tamayama",
		"Tanabe",
		"Tanage",
		"Tanikaze",
		"Tanzo",
		"Tatsuhikari",
		"Tatsunohana",
		"Tebakari",
		"Tenkaiho",
		"Tennozan",
		"Tenryu",
		"Tensuiyama",
		"Terao",
		"Terasawa",
		"Terukuni",
		"Terunofuji",
		"Terunoumi",
		"Terutsuyoshi",
		"Teruzakura",
		"Tobizaru",
		"Tochiakagi",
		"Tochiazuma",
		"Tochifudo",
		"Tochifuji",
		"Tochigiyama",
		"Tochihikari",
		"Tochihiryu",
		"Tochiisami",
		"Tochiizumi",
		"Tochikamiyama",
		"Tochimaru",
		"Tochimatoi",
		"Tochinishiki",
		"Tochinobori",
		"Tochinohana",
		"Tochinonada",
		"Tochinoshin",
		"Tochinoumi",
		"Tochinowaka",
		"Tochioyama",
		"Tochiozan",
		"Tochisakae",
		"Tochitsukasa",
		"Togashi",
		"Tohakuryu",
		"Toki",
		"Tokibayama",
		"Tokinosato",
		"Tokitenku",
		"Tokitsunada",
		"Tokitsuumi",
		"Tokitsuyama",
		"Tokusegawa",
		"Tokushinho",
		"Tokushoryu",
		"Tomikaze",
		"Tominohana",
		"Tomoefuji",
		"Tomokaze",
		"Tomonohana",
		"Tomonoshima",
		"Torokio",
		"Toronoyama",
		"Toryu",
		"Tosaeizan",
		"Tosanoumi",
		"Tosayutaka",
		"Towanoyama",
		"Toyohibiki",
		"Toyonishiki",
		"Toyonobori",
		"Toyonokuni",
		"Toyonoshima",
		"Toyonoumi",
		"Toyozakura",
		"Tsukasaumi",
		"Tsunenishiki",
		"Tsunenohana",
		"Tsurugamine",
		"Tsurugidake",
		"Tsurugisho",
		"Tsushimanada",
		"Uchida",
		"Udagawa",
		"Umegatani",
		"Ura",
		"Ushiomaru",
		"Wajima",
		"Wakaazuma",
		"Wakabayama",
		"Wakachichibu",
		"Wakachikara",
		"Wakafutase",
		"Wakahaguro",
		"Wakaichiro",
		"Wakajishi",
		"Wakakirin",
		"Wakakoma",
		"Wakakosho",
		"Wakakoyu",
		"Wakamisugi",
		"Wakamiyama",
		"Wakamotoharu",
		"Wakanami",
		"Wakanohana",
		"Wakanoho",
		"Wakanojo",
		"Wakanokuni",
		"Wakanosato",
		"Wakanoshima",
		"Wakanosho",
		"Wakanoyama",
		"Wakasegawa",
		"Wakashima",
		"Wakashimazu",
		"Wakashoji",
		"Wakashoyo",
		"Wakasugiyama",
		"Wakatakakage",
		"Wakatakami",
		"Wakatenro",
		"Wakatenryu",
		"Wakatoba",
		"Wakatoryu",
		"Wakatsutomu",
		"Wakayashima",
		"Washuyama",
		"Wayama",
		"Yago",
		"Yamada",
		"Yamaguchi",
		"Yamamotoyama",
		"Yamato",
		"Yashinoshima",
		"Yasome",
		"Yoshiazuma",
		"Yoshibayama",
		"Yoshikaze",
		"Yoshinohana",
		"Yoshinomine",
		"Yoshinotani",
		"Yoshioyama",
		"Yotsuguruma",
		"Yotsukasa",
		"Yuki",
		"Yutakasho",
		"Yutakayama",
		"Zaonishiki",
		];
		names.forEach(name => {g.observe(name); });

	},
	getAName: function() {
		let name;
		do {
			name = this.generator.generate();
		} while(name.length > 13);
		return name;
	}
};